diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/tap-bridge/examples/CMakeLists.txt ns-3.36/src/tap-bridge/examples/CMakeLists.txt
--- ns-3.35/src/tap-bridge/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/tap-bridge/examples/CMakeLists.txt	2022-04-30 18:23:58.154734800 -0700
@@ -0,0 +1,44 @@
+if(${ENABLE_TAP})
+  build_lib_example(
+    NAME tap-csma
+    SOURCE_FILES tap-csma.cc
+    LIBRARIES_TO_LINK
+      ${libcsma}
+      ${libtap-bridge}
+      ${libinternet}
+      ${libwifi}
+  )
+
+  build_lib_example(
+    NAME tap-csma-virtual-machine
+    SOURCE_FILES tap-csma-virtual-machine.cc
+    LIBRARIES_TO_LINK
+      ${libcsma}
+      ${libtap-bridge}
+      ${libinternet}
+  )
+
+  build_lib_example(
+    NAME tap-wifi-virtual-machine
+    SOURCE_FILES tap-wifi-virtual-machine.cc
+    LIBRARIES_TO_LINK
+      ${libcsma}
+      ${libtap-bridge}
+      ${libinternet}
+      ${libwifi}
+      ${libmobility}
+  )
+
+  build_lib_example(
+    NAME tap-wifi-dumbbell
+    SOURCE_FILES tap-wifi-dumbbell.cc
+    LIBRARIES_TO_LINK
+      ${libwifi}
+      ${libcsma}
+      ${libpoint-to-point}
+      ${libtap-bridge}
+      ${libinternet}
+      ${libapplications}
+  )
+
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/tap-bridge/examples/tap-csma.cc ns-3.36/src/tap-bridge/examples/tap-csma.cc
--- ns-3.35/src/tap-bridge/examples/tap-csma.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/tap-bridge/examples/tap-csma.cc	2022-04-30 18:23:58.154734800 -0700
@@ -51,7 +51,7 @@
 //
 // 1) Ping one of the simulated nodes
 //
-//    ./waf --run tap-csma&
+//    ./ns3 run tap-csma&
 //    ping 10.1.1.2
 //
 #include <iostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/tap-bridge/examples/tap-csma-virtual-machine.cc ns-3.36/src/tap-bridge/examples/tap-csma-virtual-machine.cc
--- ns-3.35/src/tap-bridge/examples/tap-csma-virtual-machine.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/tap-bridge/examples/tap-csma-virtual-machine.cc	2022-04-30 18:23:58.154734800 -0700
@@ -97,7 +97,7 @@
   // devices installed on both of the nodes.  The data rate and delay for the
   // channel can be set through the command-line parser.  For example,
   //
-  // ./waf --run "tap=csma-virtual-machine --ns3::CsmaChannel::DataRate=10000000"
+  // ./ns3 run "tap=csma-virtual-machine --ns3::CsmaChannel::DataRate=10000000"
   //
   CsmaHelper csma;
   NetDeviceContainer devices = csma.Install (nodes);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/tap-bridge/examples/tap-wifi-dumbbell.cc ns-3.36/src/tap-bridge/examples/tap-wifi-dumbbell.cc
--- ns-3.35/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2022-04-30 18:23:58.154734800 -0700
@@ -53,7 +53,7 @@
 //
 // 1) Ping one of the simulated nodes on the left side of the topology.
 //
-//    ./waf --run tap-wifi-dumbbell&
+//    ./ns3 run tap-wifi-dumbbell&
 //    ping 10.1.1.3
 //
 // 2) Configure a route in the linux host and ping once of the nodes on the 
@@ -61,7 +61,7 @@
 //    delays due to CBR background traffic on the point-to-point (see next
 //    item).
 //
-//    ./waf --run tap-wifi-dumbbell&
+//    ./ns3 run tap-wifi-dumbbell&
 //    sudo route add -net 10.1.3.0 netmask 255.255.255.0 dev thetap gw 10.1.1.2
 //    ping 10.1.3.4
 //
@@ -77,7 +77,7 @@
 //    reflected in large delays seen by ping.  You can crank down the CBR 
 //    traffic data rate and watch the ping timing change dramatically.
 //
-//    ./waf --run "tap-wifi-dumbbell --ns3::OnOffApplication::DataRate=100kb/s"&
+//    ./ns3 run "tap-wifi-dumbbell --ns3::OnOffApplication::DataRate=100kb/s"&
 //    sudo route add -net 10.1.3.0 netmask 255.255.255.0 dev thetap gw 10.1.1.2
 //    ping 10.1.3.4
 //
@@ -93,7 +93,7 @@
 //    sudo brctl addif mybridge mytap1
 //    sudo brctl addif mybridge mytap2
 //    sudo ifconfig mybridge 10.1.1.5 netmask 255.255.255.0 up
-//    ./waf --run "tap-wifi-dumbbell --mode=UseBridge --tapName=mytap2"&
+//    ./ns3 run "tap-wifi-dumbbell --mode=UseBridge --tapName=mytap2"&
 //    ping 10.1.1.3
 
 #include <iostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/tap-bridge/model/tap-bridge.h ns-3.36/src/tap-bridge/model/tap-bridge.h
--- ns-3.35/src/tap-bridge/model/tap-bridge.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/tap-bridge/model/tap-bridge.h	2022-04-30 18:23:58.154734800 -0700
@@ -49,15 +49,15 @@
 
 /**
  * \ingroup tap-bridge
- * 
- * \brief A bridge to make it appear that a real host process is connected to 
+ *
+ * \brief A bridge to make it appear that a real host process is connected to
  * an ns-3 net device.
  *
  * The Tap Bridge lives in a kind of a gray world somewhere between a
  * Linux host and an ns-3 bridge device.  From the Linux perspective,
  * this code appears as the user mode handler for a Tap net device.  That
  * is, when the Linux host writes to a /dev/tap device (that is either
- * manually or automatically created depending on basic operating mode 
+ * manually or automatically created depending on basic operating mode
  * -- more on this later), the write is redirected into the TapBridge that
  * lives in the ns-3 world; and from this perspective, becomes a read.
  * In other words, a Linux process writes a packet to a tap device and
@@ -70,7 +70,7 @@
  * the host using the Linux TAP mechanism.  This write to the device will
  * then appear to the Linux host as if a packet has arrived on its
  * device.
- * 
+ *
  * The upshot is that the Tap Bridge appears to bridge a tap device on a
  * Linux host in the "real world" to an ns-3 net device in the simulation
  * and make is appear that a ns-3 net device is actually installed in the
@@ -81,12 +81,12 @@
  * Linux.  This is not just arbitrary policy, it is because:
  *
  * - Bits sent to the Tap Bridge from higher layers in the ghost node (using
- *   the TapBridge Send() method) are completely ignored.  The Tap Bridge is 
+ *   the TapBridge Send() method) are completely ignored.  The Tap Bridge is
  *   not, itself, connected to any network, neither in Linux nor in ns-3;
  * - The bridged ns-3 net device is has had its receive callback disconnected
- *   from the ns-3 node and reconnected to the Tap Bridge.  All data received 
- *   by a bridged device will be sent to the Linux host and will not be 
- *   received by the node.  From the perspective of the ghost node, you can 
+ *   from the ns-3 node and reconnected to the Tap Bridge.  All data received
+ *   by a bridged device will be sent to the Linux host and will not be
+ *   received by the node.  From the perspective of the ghost node, you can
  *   send over this device but you cannot ever receive.
  *
  * Of course, if you understand all of the issues you can take control of
@@ -145,7 +145,7 @@
    * \param bridgedDevice device to set
    *
    * \attention The ns-3 net device that is being set as the device must have an
-   * an IP address assigned to it before the simulation is run.  This address 
+   * an IP address assigned to it before the simulation is run.  This address
    * will be used to set the hardware address of the host Linux device.
    */
   void SetBridgedNetDevice (Ptr<NetDevice> bridgedDevice);
@@ -156,7 +156,7 @@
    * The tap bridge consumes a non-trivial amount of time to start.  It starts
    * up in the context of a scheduled event to ensure that all configuration
    * has been completed before extracting the configuration (IP addresses, etc.)
-   * In order to allow a more reasonable start-up sequence than a thundering 
+   * In order to allow a more reasonable start-up sequence than a thundering
    * herd of devices, the time at which each device starts is also configurable
    * bot via the Attribute system and via this call.
    *
@@ -219,8 +219,8 @@
 protected:
   /**
    * Call out to a separate process running as suid root in order to get our
-   * tap device created.  We do this to avoid having the entire simulation 
-   * running as root.  If this method returns, we'll have a socket waiting 
+   * tap device created.  We do this to avoid having the entire simulation
+   * running as root.  If this method returns, we'll have a socket waiting
    * for us in m_sock that we can use to talk to the tap device.
    */
   virtual void DoDispose (void);
@@ -253,8 +253,8 @@
 
   /**
    * Call out to a separate process running as suid root in order to get our
-   * tap device created.  We do this to avoid having the entire simulation 
-   * running as root.  If this method returns, we'll have a socket waiting 
+   * tap device created.  We do this to avoid having the entire simulation
+   * running as root.  If this method returns, we'll have a socket waiting
    * for us in m_sock that we can use to talk to the tap device.
    */
   void CreateTap (void);
@@ -271,11 +271,13 @@
 
   /**
    * Callback to process packets that are read
+   * \param buf input buffer
+   * \param len input buffer length
    */
   void ReadCallback (uint8_t *buf, ssize_t len);
 
   /**
-   * Forward a packet received from the tap device to the bridged ns-3 
+   * Forward a packet received from the tap device to the bridged ns-3
    * device
    *
    * \param buf A character buffer containing the actual packet bits that were
@@ -289,17 +291,17 @@
    * checking on a received packet to make sure it isn't too evil for our
    * poor naive virginal simulator to handle.
    *
-   * \param packet The packet we received from the host, and which we need 
+   * \param packet The packet we received from the host, and which we need
    *               to check.
    * \param src    A pointer to the data structure that will get the source
    *               MAC address of the packet (extracted from the packet Ethernet
    *               header).
    * \param dst    A pointer to the data structure that will get the destination
-   *               MAC address of the packet (extracted from the packet Ethernet 
+   *               MAC address of the packet (extracted from the packet Ethernet
    *               header).
-   * \param type   A pointer to the variable that will get the packet type from 
+   * \param type   A pointer to the variable that will get the packet type from
    *               either the Ethernet header in the case of type interpretation
-   *               (DIX framing) or from the 802.2 LLC header in the case of 
+   *               (DIX framing) or from the 802.2 LLC header in the case of
    *               length interpretation (802.3 framing).
    * \returns the packet, or null if the packet has been filtered.
    */
@@ -410,8 +412,8 @@
   /**
    * The MAC address to use as the hardware address on the host; only used
    * in UseLocal mode.  This value comes from the MAC
-   * address assigned to the bridged ns-3 net device and matches the MAC 
-   * address of the underlying network TAP which we configured to have the 
+   * address assigned to the bridged ns-3 net device and matches the MAC
+   * address of the underlying network TAP which we configured to have the
    * same value.
    */
   Mac48Address m_tapMac;
@@ -438,7 +440,7 @@
 
   /**
    * a copy of the node id so the read thread doesn't have to GetNode() in
-   * in order to find the node ID.  Thread unsafe reference counting in 
+   * in order to find the node ID.  Thread unsafe reference counting in
    * multithreaded apps is not a good thing.
    */
   uint32_t m_nodeId;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/test/CMakeLists.txt ns-3.36/src/test/CMakeLists.txt
--- ns-3.35/src/test/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/test/CMakeLists.txt	2022-04-30 18:23:58.154734800 -0700
@@ -0,0 +1,106 @@
+set(dsr_sources)
+
+# cmake-format: off
+if((dsr IN_LIST ns3-all-enabled-modules)
+    AND (uan IN_LIST ns3-all-enabled-modules)
+    AND (olsr IN_LIST ns3-all-enabled-modules))
+  set(dsr_sources traced/traced-callback-typedef-test-suite.cc)
+endif()
+# cmake-format: on
+
+set(application_sources)
+set(csma_sources)
+set(wifi_sources)
+if(applications
+   IN_LIST
+   ns3-all-enabled-modules
+)
+  if(point-to-point
+     IN_LIST
+     ns3-all-enabled-modules
+  )
+    # cmake-format: off
+    set(applications_sources
+        ns3tcp/ns3tcp-loss-test-suite.cc
+        ns3tcp/ns3tcp-no-delay-test-suite.cc
+        ns3tcp/ns3tcp-socket-test-suite.cc
+        ns3tcp/ns3tcp-state-test-suite.cc
+    )
+    # cmake-format: on
+  endif()
+  if(wifi
+     IN_LIST
+     ns3-all-enabled-modules
+  )
+    set(wifi_sources
+        ns3wifi/wifi-issue-211-test-suite.cc
+        ns3wifi/wifi-ac-mapping-test-suite.cc
+        ns3wifi/wifi-msdu-aggregator-test-suite.cc
+    )
+  endif()
+  if((csma-layout
+      IN_LIST
+      ns3-all-enabled-modules
+     )
+     AND (internet-apps
+          IN_LIST
+          ns3-all-enabled-modules
+         )
+  )
+    set(csma_sources
+        csma-system-test-suite.cc
+    )
+  endif()
+endif()
+
+set(internet_sources)
+if(internet
+   IN_LIST
+   ns3-all-enabled-modules
+)
+  set(internet_sources
+      ns3tcp/ns3tcp-socket-writer.cc
+  )
+endif()
+
+set(network_sources)
+if(network
+   IN_LIST
+   ns3-all-enabled-modules
+)
+  set(network_sources
+      traced/traced-value-callback-typedef-test-suite.cc
+  )
+endif()
+
+set(traffic-control_sources)
+if(traffic-control
+   IN_LIST
+   ns3-all-enabled-modules
+)
+  set(traffic-control_sources
+      ns3tc/fq-cobalt-queue-disc-test-suite.cc
+      ns3tc/fq-codel-queue-disc-test-suite.cc
+      ns3tc/fq-pie-queue-disc-test-suite.cc
+      ns3tc/pfifo-fast-queue-disc-test-suite.cc
+  )
+endif()
+
+add_library(
+  ${libtest}
+  OBJECT
+  ${PROJECT_SOURCE_DIR}/build-support/empty.cc # empty source file if only
+  # libcore is enabled
+  ${applications_sources}
+  ${csma_sources}
+  ${dsr_sources}
+  ${internet_sources}
+  ${network_sources}
+  ${traffic-control_sources}
+  ${wifi_sources}
+)
+
+add_dependencies(
+  ${libtest}
+  copy_all_headers
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/test/csma-system-test-suite.cc ns-3.36/src/test/csma-system-test-suite.cc
--- ns-3.35/src/test/csma-system-test-suite.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/test/csma-system-test-suite.cc	2022-04-30 18:23:58.154734800 -0700
@@ -51,6 +51,11 @@
 
 using namespace ns3;
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA Bridge mode test.
+ */
 class CsmaBridgeTestCase : public TestCase
 {
 public:
@@ -59,8 +64,14 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
   void SinkRx (Ptr<const Packet> p, const Address &ad);
-  uint32_t m_count;
+  uint32_t m_count; //!< Counter of received packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -155,6 +166,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_count, 10, "Bridge should have passed 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA Broadcast mode test.
+ */
 class CsmaBroadcastTestCase : public TestCase
 {
 public:
@@ -163,12 +179,26 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   * @{
+   */
   void SinkRxNode1 (Ptr<const Packet> p, const Address &ad);
   void SinkRxNode2 (Ptr<const Packet> p, const Address &ad);
+  /** @} */
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_countNode1;
-  uint32_t m_countNode2;
-  uint32_t m_drops;
+
+  uint32_t m_countNode1; //!< Counter of received packets on node 1.
+  uint32_t m_countNode2; //!< Counter of received packets on node 2.
+  uint32_t m_drops;      //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -275,6 +305,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_countNode2, 10, "Node 2 should have received 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA Multicast mode test.
+ */
 class CsmaMulticastTestCase : public TestCase
 {
 public:
@@ -283,10 +318,22 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
   void SinkRx (Ptr<const Packet> p, const Address &ad);
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_count;
-  uint32_t m_drops;
+
+  uint32_t m_count; //!< Counter of received packets.
+  uint32_t m_drops; //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -435,6 +482,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_count, 10, "Node 4 should have received 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA One Subnet mode test.
+ */
 class CsmaOneSubnetTestCase : public TestCase
 {
 public:
@@ -443,12 +495,25 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   * @{
+   */
   void SinkRxNode0 (Ptr<const Packet> p, const Address &ad);
   void SinkRxNode1 (Ptr<const Packet> p, const Address &ad);
+  /** @} */
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_countNode0;
-  uint32_t m_countNode1;
-  uint32_t m_drops;
+  uint32_t m_countNode0; //!< Counter of received packets on node 0.
+  uint32_t m_countNode1; //!< Counter of received packets on node 1.
+  uint32_t m_drops;      //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -563,6 +628,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_countNode1, 10, "Node 1 should have received 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA PacketSocket test.
+ */
 class CsmaPacketSocketTestCase : public TestCase
 {
 public:
@@ -571,10 +641,22 @@
 
 private:
   virtual void DoRun (void);
-  void SinkRx (std::string path, Ptr<const Packet> p, const Address &address);
+  /**
+   * Sink called when a packet is received by a node.
+   * \param path Sink path.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
+  void SinkRx (std::string path, Ptr<const Packet> p, const Address &ad);
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_count;
-  uint32_t m_drops;
+
+  uint32_t m_count; //!< Counter of received packets.
+  uint32_t m_drops; //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -669,6 +751,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_count, 10, "Node 0 should have received 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA PING test.
+ */
 class CsmaPingTestCase : public TestCase
 {
 public:
@@ -677,12 +764,29 @@
 
 private:
   virtual void DoRun (void);
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
   void SinkRx (Ptr<const Packet> p, const Address &ad);
+
+  /**
+   * Sink called when a PING ois received.
+   * \param context Context path (unused).
+   * \param rtt Round Trip Time (unused).
+   */
   void PingRtt (std::string context, Time rtt);
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_countSinkRx;
-  uint32_t m_countPingRtt;
-  uint32_t m_drops;
+
+  uint32_t m_countSinkRx;   //!< Counter of received packets.
+  uint32_t m_countPingRtt;  //!< Counter of PING received.
+  uint32_t m_drops;         //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -790,6 +894,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_countPingRtt, 9, "Node 2 should have been pinged 9 times");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA Raw IP test.
+ */
 class CsmaRawIpSocketTestCase : public TestCase
 {
 public:
@@ -798,10 +907,22 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
   void SinkRx (Ptr<const Packet> p, const Address &ad);
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_count;
-  uint32_t m_drops;
+
+  uint32_t m_count; //!< Counter of received packets.
+  uint32_t m_drops; //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -888,6 +1009,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_count, 10, "Node 3 should have received 10 packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA star mode test.
+ */
 class CsmaStarTestCase : public TestCase
 {
 public:
@@ -896,10 +1022,22 @@
 
 private:
   virtual void DoRun (void);
+
+  /**
+   * Sink called when a packet is received by a node.
+   * \param p Received packet (unused).
+   * \param ad Sender's address (uused).
+   */
   void SinkRx (Ptr<const Packet> p, const Address &ad);
+
+  /**
+   * Sink called when a packet is dropped.
+   * \param p Received packet (unused).
+   */
   void DropEvent (Ptr<const Packet> p);
-  uint32_t m_count;
-  uint32_t m_drops;
+
+  uint32_t m_count; //!< Counter of received packets.
+  uint32_t m_drops; //!< Counter of dropped packets.
 };
 
 // Add some help text to this case to describe what it is intended to test
@@ -1070,6 +1208,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_count, 10 * ( nSpokes * (nFill + 1)), "Hub node did not receive the proper number of packets");
 }
 
+/**
+ * \ingroup system-tests-csma
+ * 
+ * \brief CSMA TestSuite.
+ */
 class CsmaSystemTestSuite : public TestSuite
 {
 public:
@@ -1089,5 +1232,5 @@
   AddTestCase (new CsmaStarTestCase, TestCase::QUICK);
 }
 
-// Do not forget to allocate an instance of this TestSuite
+/// Do not forget to allocate an instance of this TestSuite
 static CsmaSystemTestSuite csmaSystemTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/test/doc/tests.h ns-3.36/src/test/doc/tests.h
--- ns-3.35/src/test/doc/tests.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/test/doc/tests.h	2022-04-30 18:23:58.154734800 -0700
@@ -0,0 +1,84 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/**
+ * \file
+ * \ingroup tests
+ * This file provides some doxygen documentation for the tests module.
+ */
+
+
+/**
+ * \ingroup tests
+ * \defgroup system-tests System Tests
+ * 
+ * \brief The "tests" module contains the System Tests, i.e., tests that
+ * dependss on multiple modules. Due to their dependencies, the System Tests
+ * are in this module.
+ * 
+ * Unit tests, on the contrary, are located in each module.
+ */
+
+/**
+ * \ingroup system-tests
+ * \ingroup traffic-control-test
+ * \defgroup system-tests-tc TrafficControl System Tests
+ * 
+ * \brief TrafficControl System Tests
+ */
+
+/**
+ * \ingroup system-tests
+ * \ingroup internet-test
+ * \defgroup system-tests-tcp TCP System Tests
+ * 
+ * \brief TCP System Tests
+ */
+
+/**
+ * \ingroup system-tests
+ * \ingroup wifi-test
+ * \defgroup system-tests-wifi WiFi System Tests
+ * 
+ * \brief WiFi System Tests
+ */
+
+/**
+ * \ingroup system-tests
+ * \defgroup system-tests-perf Performance System Tests
+ * 
+ * \brief Performance System Tests
+ * 
+ * Note: these tests are (for real) scripts to be run.
+ * The ouput is the time (in nanoseconds) that the test 
+ * required to perform the requested write operations.
+ */
+
+/**
+ * \ingroup system-tests
+ * \ingroup core-tests
+ * \defgroup system-tests-traced TracedCallback System Tests
+ * 
+ * \brief TracedCallback System Tests
+ */
+
+/**
+ * \ingroup system-tests
+ * \ingroup csma
+ * \defgroup system-tests-csma CSMA System Tests
+ * 
+ * \brief CSMA System Tests
+ */
